module Hikki
  module Adapters
    class MemoryAdapter < Hikki::Adapters::Adapter
      attr_reader :store, :uuid_generator, :collections

      def initialize(uuid_generator=SecureRandom)
        super()
        @uuid_generator = uuid_generator
        @store = {}
        @collections = {}
      end

      def collection_for(collection)
        collections.fetch(collection, MemoryCollection.new(collection, store, uuid_generator))
      end
    end
  end
end