require 'json'

module Hikki
  class Collection
    attr_reader :collection

    def initialize(collection)
      @collection = collection.to_s
    end

    def index(field)
      raise 'Implementation missing.'
    end

    def save(data)
      raise 'Implementation missing.'
    end

    def find(id)
      raise 'Implementation missing.'
    end

    def all(options)
      raise 'Implementation missing.'
    end

    def find_by(field, value, options)
      raise 'Implementation missing.'
    end

    def remove(id)
      raise 'Implementation missing.'
    end

    def remove_all
      raise 'Implementation missing.'
    end

    def normalize_data(data)
      deep_copy(data).tap { |d| d.merge!('id' => id_for(d)) }
    end

    def deep_copy(h)
      JSON.parse(h.to_json)
    end

    def id_for(data)
      data.fetch('id', 'undefined').to_s
    end

    def normalize_options(options)
      {
        limit: options[:limit] || options['limit'] || -1,
        offset: options[:offset] || options['offset'] || 0
      }
    end

    def page_range(options)
      (options[:offset]..(options[:limit] == -1 ? -1 : options[:offset] + options[:limit] - 1))
    end
  end
end